/* lib/getdba.p
 *
 * read proutil dbanalys data, cache the results in dbname.dbx
 *
 * there is a lot of legacy cruft and sloppy coding hanging around in here -- it needs to be cleaned up some day.
 *
 * pro dbname -RO ; run lib/getdba.p ( "dbanalys/dbname.dba" )
 *
 */

{lib/protop.i}

{lib/dba.i}

define new global shared variable dbgMode as integer no-undo initial 1.

define variable r          as integer   no-undo.
define variable x          as character no-undo.
define variable y          as decimal   no-undo.
define variable z          as decimal   no-undo.
define variable xline      as character no-undo extent 512.
define variable curr_area  as character no-undo.
define variable doFixed    as logical   no-undo initial no.
define variable bSize      as integer   no-undo initial 4096.

define variable ztblName as character no-undo.
define variable zidxName as character no-undo.

define stream inStrm.


procedure getTableInfo:

  define input   parameter tblName as character no-undo.
  define output  parameter numRecs as decimal   no-undo.
  define output  parameter numRM   as decimal   no-undo.
  define output  parameter fragPct as decimal   no-undo.
  define output  parameter scatter as decimal   no-undo.
  define output  parameter avgRow  as decimal   no-undo.

  find tblist where tbl = tblName no-error.
  if available tblist then
    assign
      numRecs = tblist.recs
      numRM   = tblist.rm
      fragPct = ( if tblist.recs > 0 then ((( tblist.frag / tblist.recs ) - 1 ) * 100 ) else 0 )
      scatter = tblist.scat
      avgRow  = ( if tblist.recs > 0 then ( tblist.tsz / tblist.recs ) else 0 )
    .

  return.

end.


procedure getIndexInfo:

  define input   parameter idxName     as character no-undo.
  define output  parameter idxLevels   as decimal   no-undo.
  define output  parameter numBlocks   as decimal   no-undo.
  define output  parameter pctUtilized as decimal   no-undo.

  find ixlist where idx = idxName no-error.
  if available ixlist then
    assign
      idxLevels   = ixlist.lvls
      numBlocks   = ixlist.blks
      pctUtilized = ixlist.pctut
    .

  return.

end.


procedure getLOBInfo:

  define input   parameter LOBName     as character no-undo.
  define output  parameter LOBrecs     as decimal   no-undo.
  define output  parameter LOBminSz    as decimal   no-undo.
  define output  parameter LOBmaxSz    as decimal   no-undo.
  define output  parameter LOBavgSz    as decimal   no-undo.

  find lxlist where LOB = LOBName no-error.
  if available lxlist then
    assign
      LOBrecs  = lxlist.recs
      LOBminSz = lxlist.minLOB
      LOBmaxSz = lxlist.maxLOB
      LOBavgSz = lxlist.avgLOB
    .

  return.

end.


define variable dbxDate as date    no-undo.
define variable dbxTime as integer no-undo.

procedure loadDBX:

  define input parameter dbxOutFile as character no-undo.

  /* we are assuming that .dbx, .idx, and .lbx are all written at the same time
   */

  file-info:file-name = right-trim( dbxOutFile, "dba" ) + "dbx".
  if file-info:full-pathname = ? then
    do:
      if dbgMode >= 5 then
        message now "Unable to find:" dbxOutfile.
      return.
    end.

  if dbxDate = file-info:file-mod-date and dbxTime = file-info:file-mod-time then
    do:
      /* message now "already loaded:" file-info:file-name. pause. */
      return.									/* we have already loaded this so just return	*/
    end.

  assign
    dbxDate = file-info:file-mod-date
    dbxTime = file-info:file-mod-time
  .

  if dbgMode >= 2 then message now "Loading dbanalys data".

  /* message now "loading:" right-trim( dbxOutFile, "dba" ) + "dbx". pause. */

  empty temp-table tblist.
  empty temp-table ixlist.
  empty temp-table lxlist.

  file-info:file-name = right-trim( dbxOutFile, "dba" ) + "dbx".
  if file-info:full-pathname <> ? then
    do:
      input stream inStrm from value( right-trim( dbxOutFile, "dba" ) + "dbx" ).
      repeat:
        create tblist.
        import stream inStrm tblist.
      end.
      input stream inStrm close.
    end.

  file-info:file-name = right-trim( dbxOutFile, "dba" ) + "idx".
  if file-info:full-pathname <> ? then
    do:
      input stream inStrm from value( right-trim( dbxOutFile, "dba" ) + "idx" ).
      repeat:
        create ixlist.
        import stream inStrm ixlist.
      end.
      input stream inStrm close.
    end.

  file-info:file-name = right-trim( dbxOutFile, "dba" ) + "lbx".
  if file-info:full-pathname <> ? then
    do:
      input stream inStrm from value( right-trim( dbxOutFile, "dba" ) + "lbx" ).
      repeat:
        create lxlist.
        import stream inStrm lxlist.
      end.
      input stream inStrm close.
    end.

  for each tblist where tbl = "":
    delete tblist.
  end.

  for each ixlist where idx = "":
    delete ixlist.
  end.

  for each lxlist where lob = "":
    delete lxlist.
  end.

  if dbgMode >= 4 then message now "Done loading dbanalys data".

  return.

end.


define variable dbaDate as date    no-undo.
define variable dbaTime as integer no-undo.

define variable dbaNag  as logical no-undo.

procedure checkDBX:

  define variable dbaOutFile as character no-undo.

  dbaOutFile = search( "dbanalys/" + pt_shortname + ".dba" ).			/* first look for dbanalys/pt_shortname.dba	*/
  if dbaOutFile = ? then
    dbaOutFile = search( "dbanalys/" + ldbname(1) + ".dba" ).			/* then look for dbanalys/ldbname(1).dba	*/

  /* Multi-tenancy requires dbanalys CSV files:
     Shortname.tab.txt, shortname.idx.txt, shortname.lob.txt, shortname.ch.txt 
     In phase 1, we don't support names like <dbname>.tab.txt; it must be <pt_shortname>.tab.txt. 
     In future, the above will apply to table partitioning-enabled databases as well. */
  if isDBFeatureActive( 14 ) then
    do:
      /* MT is enabled so we require CSV files */
      dbaOutFile = search( "dbanalys/" + pt_shortname + ".tab.txt" ).
      
      /* if we didn't find it, give up */
      if dbaOutFile = ? then
        do:
          if dbgMode >= 2 then message now substitute( "checkDBX: Multi-tenancy is enabled and dbanalys CSV file &1 was not found.", dbaOutFile ).
        end.  
    end.
  
  file-info:file-name = dbaOutFile.
  if file-info:full-pathname = ? then
    do:

      if dbaNag = no then
        do:

          dbaNag = yes.

          if isDBFeatureActive( 14 ) then      /* multi-tenancy */
            do:
              
              if session:batch = yes then
                message now "Unable to find dbanalys: dbanalys/" + pt_shortname + "tab.txt".
              
              else
                message color red
                  skip(1)
                  "   Unable to find dbanalys CSV files in ProTop~'s dbanalys directory for   " skip
                  pt_shortname + ". The files must be named as follows:                       " skip
                  "       " pt_shortname + ".tab.txt                                          " skip
                  "       " pt_shortname + ".ix.txt                                           " skip
                  "       " pt_shortname + ".lob.txt (11.6+ only)                             " skip
                  skip(1)
                  "   ProTop uses this data to enrich the table and index activity screens.   " skip
                  "   Without dbanalys data some features are limited.                        " skip
                  skip(1)
                  "   Ideally you will routinely run a fresh dbanalys at least weekly.        " skip
                  skip(1)
                  "   To run it manually use a command similar to:                            " skip
                  skip(1)
                  substitute( "  proutil &1 -C dbanalys -csoutput -verbose -csfilePrefix &2 -Bp 10 > &2.dba  ", ldbname(1), pt_shortname ) skip
                  skip(1)
                  "   and then copy the resulting *.txt files to ProTop~'s dbanalys directory." skip
                  /*
                  In phase 1 of MT support, we don't support running a CSV dbanalys from within ProTop
                  
                  '   You can also run dbanalys directly within ProTop with the "!" command.  ' skip
                  "   (But be aware that this command is IO intense - you may prefer to run   " skip
                  "   it during non-peak hours.)                                              " skip
                  */
                  skip(1)
                  view-as alert-box information
                  title " No DB Analys "
                .
                  
            end.
          
          else
            do:    

              if session:batch = yes then
                message now "Unable to find dbanalys:" pt_shortname "or" ldbname(1).
               else
                message color red
                  skip(1)
                  "   Unable to find dbanalys for:" pt_shortname "or" ldbname(1)  skip
                  skip(1)
                  "   ProTop uses this data to enrich the table and index activity screens.   " skip
                  "   Without dbanalys data some features are limited.                        " skip
                  skip(1)
                  "   Ideally you will routinely run a fresh dbanalys at least weekly.        " skip
                  skip(1)
                  "   To run it manually use a command similar to:                            " skip
                  skip(1)
                  substitute( "  proutil &1 -C dbanalys -Bp 10 > dbanalys/&2.dba  ", ldbname(1), ( if pt_shortname <> "" then pt_shortname else ldbname(1) )) skip
                  skip(1)
                  '   You can also run dbanalys directly within ProTop with the "!" command.  ' skip
                  "   (But be aware that this command is IO intense - you may prefer to run   " skip
                  "   it during non-peak hours.)                                              " skip
                  skip(1)
                  view-as alert-box information
                  title " No DB Analys "
                .
          end.

        end.

      return.

    end.

  assign
    dbaDate = file-info:file-mod-date
    dbaTime = file-info:file-mod-time
  .

  /* which is more recent: the unparsed dbanalys report (.dba or .tab.txt) or the ProTop-parsed version of it (.dbx)? */

  if isDBFeatureActive( 14 ) /* or proversion >= '11.4' */ then
    do:
      file-info:file-name = pt_shortname + ".dbx".
      
      if file-info:full-pathname = ? or
         dbaDate > file-info:file-mod-date or
       ( dbaDate = file-info:file-mod-date and dbaTime > file-info:file-mod-time ) then
        do:
          /* either the parsed data doesn't exist or it's older than the dbanalys table CSV file, so parse the CSV files */
          run parseTableCSV( dbaOutFile ).                                       /* dbanalys/<pt_shortname>.tab.txt */
          run parseIndexCSV( "dbanalys/" + pt_shortname + ".ix.txt" ).
          run parseChainCSV( "dbanalys/" + pt_shortname + ".ch.txt" ).
          run parseLOBCSV  ( "dbanalys/" + pt_shortname + ".lob.txt" ).
          /* run parseBlockCSV( "dbanalys/" + pt_shortname + ".block.txt" ).     we can enable this once it does something useful */
        end.
    
       else
        do:
          /* the parsed data is newer than the dbanalys report, so load it */
          run loadDBX( dbaOutFile ).
        end.
      
    end.
    
  else
    do:
      file-info:file-name = right-trim( dbaOutFile, "dba" ) + "dbx".
      
      if file-info:full-pathname = ? or
         dbaDate > file-info:file-mod-date or
       ( dbaDate = file-info:file-mod-date and dbaTime > file-info:file-mod-time ) then
        do:
          /* the parsed data doesn't exist, or it's older than the dbanalys report, so parse the report */
          run parseDBA( dbaOutFile ).
        end.
    
       else
        do:
          /* the parsed data is newer than the dbanalys report, so load it */
          run loadDBX( dbaOutFile ).
        end.
        
    end.

  return.

end.

{ssg/sausage20.i}

/*** main block (constructor)
 ***
 ***/

session:add-super-procedure( this-procedure ).

run checkDBX.

return.
